<?php

Yii::setAlias('@tests', dirname(__DIR__) . '/tests/codeception');

$params = require(__DIR__ . '/params.php');
$db = require(__DIR__ . '/db.php');

$config = [
    'id' => 'medkey-console',
    'basePath' => dirname(__DIR__),
    'bootstrap' => ['log'],
    'controllerNamespace' => 'app\commands',
    'components' => [
        'cache' => [
            'class' => 'yii\caching\FileCache',
        ],
        'authManager' => [
            'class' => \app\modules\security\common\rbac\AccessManager::class,
        ],
        'configManager' => [
            'class' => \app\common\config\ConfigManager::class,
        ],
        'urlManager' => [
            'baseUrl' => '',
            'enablePrettyUrl' => true,
            'showScriptName' => false,
            'rules' => [
                [
                    'pattern' => '<module>/<controller>/<action>',
                    'route' => '<module>/<controller>/<action>',
                    'suffix' => ''
                ],
            ]
        ],
        'log' => [
            'targets' => [
                [
                    'class' => 'yii\log\FileTarget',
                    'levels' => ['error', 'warning'],
                ],
                [
                    'class' => 'yii\log\DbTarget',
                    'levels' => ['error', 'warning'],
                ],
            ],
        ],
        'db' => $db,
        'seeder' => [
        	'class' => 'app\common\seeds\Seeder',
        ],
        'dependencyFactory' => [
            'class' => 'app\common\dependencies\DependencyFactory',
        ],
    ],
    'modules' => [
        'config' => [
            'class' => \app\modules\config\ConfigModule::class,
        ],
    ],
    'params' => $params,
];

return $config;