<?php

use app\common\db\Migration;

/**
 * Class m170426_135836_organization_init
 * 
 */
class m170426_135836_organization_init extends Migration
{
    /**
     * @inheritdoc
     */
    public function safeUp()
    {
        $this->createBothTables('{{%organization}}', [
            'title' => $this->string(),
            'short_title' => $this->string(),
            'description' => $this->text()
        ]);
        $this->createBothTables('{{%department}}', [
            'organization_id' => $this->foreignKeyId(),
            'title' => $this->string(),
            'short_title' => $this->string(),
            'description' => $this->text()
        ]);
        $this->createBothTables('{{%position}}', [
            'department_id' => $this->foreignKeyId(),
            'title' => $this->string(),
            'short_title' => $this->string(),
            'description' => $this->text()
        ]);
        $this->createBothTables('{{%employee}}', [
            'user_id' => $this->foreignKeyId(),
            'first_name' => $this->string(),
            'middle_name' => $this->string(),
            'last_name' => $this->string(),
            'status' => $this->smallInteger(),
            'sex' => $this->smallInteger(),
            'education' => $this->string(),
            'birthday' => $this->date()
        ]);
        $this->createBothTables('{{%speciality}}', [
            'title' => $this->string(),
            'short_title' => $this->string(),
            'description' => $this->text()
        ]);
        $this->createBothTables('{{%employee_to_speciality}}', [
            'speciality_id' => $this->foreignKeyId(),
            'employee_id' => $this->foreignKeyId(),
        ]);
        $this->createBothTables('{{%cabinet}}', [
            'number' => $this->integer()->notNull(),
            'description' => $this->text(),
            'organization_id' => $this->foreignKeyId(),
            'department_id' => $this->foreignKeyId(),
        ]);
    }

    /**
     * @inheritdoc
     */
    public function safeDown()
    {
        $this->dropBothTables('{{%employee}}');
        $this->dropBothTables('{{%organization}}');
        $this->dropBothTables('{{%department}}');
        $this->dropBothTables('{{%position}}');
        $this->dropBothTables('{{%speciality}}');
        $this->dropBothTables('{{%employee_to_speciality}}');
        $this->dropBothTables('{{cabinet}}');
    }
}
