<?php
namespace app\modules\crm\workflow\subscribers;

use app\common\dto\Dto;
use app\modules\crm\models\orm\Order;
use app\modules\medical\application\ReferralServiceInterface;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\Workflow\Event\Event;

/**
 * Class OrderStateSubscriber
 * @package app\modules\crm\workflow\subscribers
 *
 * 
 */
class OrderStateSubscriber implements EventSubscriberInterface, OrderStateSubscriberInterface
{
    /**
     * @inheritdoc
     */
    public static function getSubscribedEvents()
    {
        return [
            'workflow.paid_order.entered.' . Order::STATUS_PAID => 'onPaid',
        ];
    }

    public function onPaid(Event $e)
    {
        /** @var Order $order */
        $order = $e->getSubject();
        if (!$order->save()) {
        }
        $o = $order->toArray([], ['orderItems']);
        $orderDto = Dto::make($o);
        /** @var ReferralServiceInterface $referralAppService */
        $referralAppService = \Yii::$container->get(ReferralServiceInterface::class);
        $referralAppService->generateReferralByOrder($orderDto);
    }
}
