<?php
namespace app\modules\dashboard\application;

use app\common\dto\Dto;
use app\common\service\ServiceInterface;
use app\modules\dashboard\models\finders\DashboardFinder;

/**
 * Interface DashboardServiceInterface
 * @package app\modules\dashboard\application
 *
 * 
 */
interface DashboardServiceInterface extends ServiceInterface
{
    /**
     * Get user's dashboards collection
     * @param DashboardFinder $filterModel
     * @return mixed
     */
    public function getCollectionForUserByFilterModel($filterModel = null);

    /**
     * @param Dto $dashboardDto
     * @return mixed
     */
    public function getOneForUser($dashboardDto);

    /**
     * @param null $filterModel
     * @return mixed
     */
    public function getAllCollectionByFilterModel($filterModel = null);

}
