<?php
namespace app\modules\medical\models\orm;

use app\common\db\ActiveRecord;
use app\common\helpers\CommonHelper;

/**
 * Class Policy
 * @package app\common\logic\orm
 */
class Policy extends ActiveRecord
{
    // todo вынос в трейт

    /**
     * @return array
     */
    public static function types()
    {
        return [
            1 => 'ОМС',
            2 => 'ДМС',
        ];
    }

    /**
     * @return string|null
     */
    public function getTypeName()
    {
        $types = static::types();
        return isset($types[$this->type]) ? $types[$this->type] : null;
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [ [ 'number', 'type', 'insurance_id'], 'required' ],
            [
                [ 'expiration_date', 'issue_date' ],
                'filter',
                'filter' => function ($value) {
                    if (!empty($value)) {
                        return \Yii::$app->formatter->asDate($value, CommonHelper::FORMAT_DATE_DB);
                    }
                },
            ],
            [
                [ 'expiration_date',
                'issue_date',
                'insurance_id',
                'number',
                'series',
                'type',
                'patient_id' ],
                'string'
            ]
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabelsOverride()
    {
        return [
            'expiration_date' => 'Дата окончания',
            'issue_date' => 'Дата оформления',
            'insurance_id' => 'Страховая компания',
            'number' => 'Номер',
            'series' => 'Серия',
            'type' => 'Тип',
            'patient_id' => 'Пациент',
        ];
    }
}
