<?php
namespace app\modules\medical\models\orm;

use app\common\db\ActiveRecord;

/**
 * Class ReferralItem
 *
 * @property string $referral_id
 * @property string $service_id
 *
 * @package app\modules\medical\models\orm
 */
class ReferralItem extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [ [ 'referral_id', 'service_id' ], 'string' ]
        ];
    }

    public function getReferral()
    {
        return $this->hasOne(Referral::class, ['id' => 'referral_id']);
    }

    public function getService()
    {
        return $this->hasOne(Service::class, ['id' => 'service_id']);
    }

    /**
     * @inheritdoc
     */
    public function attributeLabelsOverride()
    {
        return [
            'service_id' => 'Медицинская услуга',
            'referral_id' => 'Направление',
        ];
    }
}
