<?php
namespace app\modules\organization\models\orm;

use app\common\db\ActiveRecord;

/**
 * Class Cabinet
 * @package app\modules\organization\models\orm
 *
 * 
 */
class Cabinet extends ActiveRecord
{
    public function rules()
    {
        // todo возможно required organization_id и department_id
        return [
            [ ['number'], 'integer' ], // todo возможно не только int
            [ ['number'], 'required' ],
            [ ['description', 'organization_id', 'department_id'], 'string' ]
        ];
    }

    public function getOrganization()
    {
        return $this->hasOne(Organization::className(), ['id' => 'organization_id']);
    }

    public function getDepartment()
    {
        return $this->hasOne(Department::className(), ['id' => 'department_id']);
    }

    public function attributeLabelsOverride()
    {
        return [
            'number' => 'Номер',
            'description' => 'Описание',
            'organization_id' => 'Организация',
            'department_id' => 'Подразделение',
        ];
    }
}
