<?php
namespace app\modules\organization\models\orm;

use app\common\db\ActiveRecord;
use app\modules\organization\OrganizationModule;

/**
 * Class Department
 * @package app\modules\organization\models\orm
 *
 * 
 */
class Department extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [ ['organization_id', 'title'], 'required', 'on' => [ActiveRecord::SCENARIO_CREATE, ActiveRecord::SCENARIO_UPDATE] ],
            [ ['organization_id', 'title', 'short_title', 'description'], 'string', 'on' => [ActiveRecord::SCENARIO_CREATE, ActiveRecord::SCENARIO_UPDATE] ]
        ];
    }

    /**
     * @return \yii\db\ActiveQueryInterface
     */
    public function getOrganization()
    {
        return $this->hasOne(Organization::className(), ['id' => 'organization_id']);
    }

    /**
     * @inheritdoc
     */
    public function attributeLabelsOverride()
    {
        return [
            'organization_id' => 'Организация',
            'department_id' => 'Подразделение',
            'title' => 'Название',
            'short_title' => 'Короткое название',
            'description' => 'Описание',
        ];
    }
}
