<?php
namespace app\modules\organization\models\orm;

use app\common\db\ActiveRecord;
use app\modules\organization\OrganizationModule;

/**
 * Class Position
 *
 * @property string $id
 * @property string $department_id
 * @property string $title
 * @property string $short_title
 * @property string $description
 *
 * @package app\modules\organization\models\orm
 *
 * 
 */
class Position extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [ ['title', 'department_id'], 'required', 'on' => [ActiveRecord::SCENARIO_CREATE, ActiveRecord::SCENARIO_UPDATE] ],
            [ ['department_id', 'title', 'short_title', 'description'], 'string', 'on' => [ActiveRecord::SCENARIO_CREATE, ActiveRecord::SCENARIO_UPDATE] ]
        ];
    }

    /**
     * @return \yii\db\ActiveQueryInterface
     */
    public function getDepartment()
    {
        return $this->hasOne(Department::className(), ['id' => 'department_id']);
    }

    /**
     * @inheritdoc
     */
    public function attributeLabelsOverride()
    {
        return [
            'department_id' => OrganizationModule::t('common', 'Department'),
            'title' => OrganizationModule::t('common', 'Title'),
            'short_title' => OrganizationModule::t('common', 'Short title'),
            'description' => OrganizationModule::t('common', 'Description'),
        ];
    }
}
