<?php
namespace app\modules\security\common\rbac;

use app\common\helpers\ArrayHelper;
use app\modules\security\models\orm\Acl;
use app\modules\security\models\orm\User;
use yii\base\BaseObject;
use yii\rbac\CheckAccessInterface;

/**
 * Class DbManager
 * @package app\common\rbac
 *
 * 
 * @deprecated
 */
class AccessManager extends BaseObject implements CheckAccessInterface
{
    /**
     * @inheritdoc
     */
    public function checkAccess($userId, $permissionName, $params = [])
    {
        return false;
    }

    public function checkEntityAccess($userId, $type, $module, $entityType, $permission)
    {
        if ($type === Acl::TYPE_RECORD) {
            return $this->checkOrm($userId, $module, $entityType, $permission);
        }
    }

    /**
     * @param string $userId
     * @param string $module
     * @param integer $entityType
     * @param integer $permission
     */
    public function checkScreen($userId, $module, $entityType, $permission)
    {

    }

    private function checkOrm($userId, $module, $entityType, $permission)
    {
        $user = User::find()
            ->setAccess(false)
            ->where([
                'id' => $userId
            ])
            ->notDeleted()
            ->one();
        if ($user === null) {
            throw new \Exception('Пользователь, переданный в параметрах, не найден.');
        }
        $roles = ArrayHelper::getColumn($user->getAccessRoleToUsers(false)->all(), 'access_role_id');
        if (empty($roles)) { // todo подумать стоит ли так делать.
            return true;
        }
        $acl = Acl::find()
            ->setAccess(false)
            ->where([
                'type' => Acl::TYPE_RECORD,
                'module' => $module,
                'entity_type' => $entityType,
                'role_id' => $roles
            ])
            ->andWhere('permission & ' . $permission . '!=0') // TODO дыра, экранировать $permission Без PERMISSION проверить
            ->all();
        if (empty($acl)) {
            // не нашли ограничений на данный permission, значит разрешено по умолчанию
            return true;
        } else {
            $result = [];
            $employeeIds = ArrayHelper::getColumn($user->getEmployees(false)->all(), 'id');
            foreach ($acl as $a) {
                $result[] = ['rule' => $a->rule, 'entityId' =>$a->entity_id];
            }
            $params = [
                Acl::RULE_RESPONSIBILITY => $employeeIds,
                Acl::RULE_DEPARTMENT => null, // TODO реализовать
                Acl::RULE_POSITION => null, // TODO реализовать
            ];
            return ['result' => $result, 'params' => $params];
        }
    }
}
