<?php
namespace app\modules\security\models\form;

use app\common\base\Model;
use app\modules\security\models\orm\User;
use yii\web\IdentityInterface;

/**
 * Class LoginForm
 * @package app\modules\security\models\form
 *
 * 
 */
class LoginForm extends Model
{
    /**
     * @var string
     */
    public $login;
    /**
     * @var string
     */
    public $password;
    /**
     * @var IdentityInterface
     */
    private $_identity;


    /**
     * @return mixed
     */
    public function getIdentity()
    {
        return $this->_identity;
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [ ['login', 'password'], 'required' ],
            [ ['login', 'password'], 'string' ],
            [ ['login'], 'validateUser' ],
        ];
    }

    /**
     * @param string $attribute
     * @return void
     */
    public function validateUser($attribute)
    {
        $user = User::find()
            ->setAccess(false)
            ->where([
                'login' => $this->login,
            ])
            ->notDeleted()
            ->one();
        $this->_identity = $user;
        if (
            $user === null
            || !\Yii::$app->getSecurity()->validatePassword($this->password, $user->password_hash)
        ) {
            $this->addError($attribute, 'Логин или пароль введены неверно.');
        }
    }
}
