<?php
namespace app\modules\security\models\orm;

use app\common\acl\role\RoleInterface;
use app\common\db\ActiveRecord;

/**
 * Class AccessRole
 * @package app\modules\security\models\orm
 *
 * 
 */
class AclRole extends ActiveRecord implements RoleInterface
{
    /**
     * @inheritdoc
     */
    public function getRoleId()
    {
        return $this->id;
    }

    /**
     * @inheritdoc
     */
    public static function modelIdentity()
    {
        return ['name'];
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [
                ['name', 'short_name', 'description'],
                'string',
                'on' => [
                    ActiveRecord::SCENARIO_CREATE,
                    ActiveRecord::SCENARIO_UPDATE
                ]
            ]
        ];
    }

    public function attributeLabelsOverride()
    {
        return [
            'name' => 'Наименование',
            'short_name' => 'Короткое наименование',
            'description' => 'Описание',
        ];
    }
}
