<?php
namespace app\port\rest\controllers;

use app\common\base\Module;
use app\common\db\ActiveRecord;
use app\common\db\ResponsibilityInterface;
use app\common\rest\Controller;
use app\modules\organization\models\orm\Employee;
use yii\web\HttpException;

/**
 * Class ResponsibilityController
 * @package app\port\rest\controllers
 *
 * 
 */
class ResponsibilityController extends Controller
{
    public function actionRelation()
    {
        $module = \Yii::$app->request->post('module');
        $entity = \Yii::$app->request->post('entity');
        $entityId = \Yii::$app->request->post('entity_id');
        $responsibilities = \Yii::$app->request->post('responsibilities');
        /** @var Module $module */
        $module = \Yii::$app->getModule($module);
        $ns = $module->getOrmNamespace();
        /** @var ActiveRecord $modelClass */
        $modelClass = $ns . '\\' . $entity;
        if (!class_exists($modelClass)) {
            throw new HttpException(400, 'Не хватает параметров для обработки запроса.');
        }
        $model = $modelClass::ensure($entityId);
        if (!$model instanceof ResponsibilityInterface) {
            throw new HttpException(400, 'Модель сущности не соответствует интерфейсу.');
        }
        $model->unlinkAll('responsibilityEmployees', true);
        if (!is_array($responsibilities)) {
            return $model;
        }
        foreach ($responsibilities as $res) {
            $employee = Employee::findOneEx($res);
            $model->link('responsibilityEmployees', $employee);
        }
        return $model;
    }
}
