<?php
namespace app\port\rest\controllers;

use app\common\dto\Dto;
use app\common\rest\Controller;
use app\common\workflow\WorkflowApplicationService;
use yii\base\Module;
use yii\web\HttpException;

/**
 * Class StateTransitionController
 * @package app\port\rest\controllers
 *
 * 
 */
class StateTransitionController extends Controller
{
    /**
     * @var WorkflowApplicationService
     */
    public $workflowService;


    /**
     * StateTransitionController constructor.
     * @param string $id
     * @param Module $module
     * @param WorkflowApplicationService $workflowService
     * @param array $config
     */
    public function __construct($id, Module $module, WorkflowApplicationService $workflowService, array $config = [])
    {
        $this->workflowService = $workflowService;
        parent::__construct($id, $module, $config);
    }

    public function actionApply()
    {
        $params = \Yii::$app->request->getBodyParams();
        if (
            empty($params['workflowModule'])
            || empty($params['workflowClass'])
            || empty($params['transitionName'])
            || empty($params['ormClass'])
            || empty($params['ormId'])
            || empty($params['ormModule'])
        ) {
            throw new HttpException(400, 'Отсутствуют обязательные поля для обработки запроса.');
        }
        return $this->workflowService->applyTransition(Dto::make($params));
    }
}
