<?php
namespace app\common\card; use app\common\button\ButtonGroup; use app\common\db\ActiveRecord; use app\common\db\ActiveRecordRegistry; use app\common\widgets\ActiveForm; use app\common\widgets\FormWidget; use app\common\widgets\Widget; use app\common\helpers\Html; use app\common\workflow\StateMachine; use yii\base\Model; use app\common\helpers\ClassHelper; use yii\db\ActiveRecordInterface; class CardView extends Widget { const MODE_FULL = 1; const MODE_STRIPPED = 2; public $model; public $subpanelGroupClass = SubpanelGroup::class; public $actionButtonGroupClass = ButtonGroup::class; public $stateButtonGroupClass = ButtonGroup::class; public $formOptions = array(); protected $stateMachine; public $visibleSubpanels = true; public $pushState = true; public $redirectSubmit = false; public $mode = self::MODE_FULL; public $headerTag = 'div'; private $modelClass; public function getStateMachine() { return $this->stateMachine; } public function init() { if (!isset($this->clientClassNameDefault)) { $this->clientClassNameDefault = ClassHelper::getShortName(__CLASS__); } $this->prepareModel(); $this->prepareModelScenario(); if ($this->model instanceof ActiveRecordInterface && $this->model->isNewRecord) { $this->visibleSubpanels = false; } elseif ($this->model instanceof Model && empty($this->model->id)) { $this->visibleSubpanels = false; } elseif (empty($this->subpanels())) { $this->visibleSubpanels = false; } if ($this->model instanceof ActiveRecordInterface && $this->model->isNewRecord) { $this->mode = self::MODE_STRIPPED; } elseif ($this->model instanceof Model && empty($this->model->id)) { $this->mode = self::MODE_STRIPPED; } $this->clientViewOptions['scenario'] = $this->model->scenario; $this->clientViewOptions['pushState'] = $this->pushState; $this->clientViewOptions['formOptions'] = $this->formOptions; $this->clientViewOptions['mode'] = $this->mode; $this->clientViewOptions['redirectSubmit'] = $this->redirectSubmit; parent::init(); } public function run() { echo Html::beginRow(); echo Html::beginCol(array('size' => array('xs' => 12))); echo Html::beginDiv(array('class' => 'b-card__title')); echo Html::beginTag($this->headerTag); echo $this->title(); echo Html::endTag($this->headerTag); echo Html::endDiv(); echo Html::endCol(); echo Html::endRow(); $this->mode !== self::MODE_FULL ?: $this->renderButtons(); echo '<br />'; $this->renderBody(); $this->renderAfter(); } public function prepareModel() { if (!$this->model instanceof Model) { $spf4c2af = \Yii::$app->getModule($this->getModule()); $sp294075 = ActiveRecordRegistry::getNamespace($spf4c2af->getUniqueId(), str_replace('Card', '', ClassHelper::getShortName(static::className()))); $this->model = $sp294075::ensureWeak($this->model); } } public function prepareModelScenario() { $spaa1573 = \Yii::$app->request->getQueryParam('scenario'); if (!empty($spaa1573)) { $this->model->setScenario($spaa1573); } } protected function subpanels() { return array(); } public function dataGroups() { return array(); } public function renderBody() { echo Html::beginTag('div', array('class' => 'row')); echo Html::beginTag('div', array('class' => 'col-md-12')); echo $this->renderData(); echo Html::endTag('div'); echo Html::endTag('div'); if ($this->visibleSubpanels) { echo Html::beginTag('div', array('class' => 'row')); echo Html::beginTag('div', array('class' => 'col-md-12')); $this->renderSubpanels(); echo Html::endTag('div'); echo Html::endTag('div'); } } public function renderButtons() { echo Html::beginTag('div', array('class' => 'row')); echo Html::beginTag('div', array('class' => 'col-md-1')); echo $this->renderStateButtons(); echo Html::endTag('div'); echo Html::beginTag('div', array('class' => 'col-md-11')); echo $this->renderActionButtons(); echo Html::endTag('div'); echo Html::endTag('div'); } protected function renderAfter() { } protected function title() { return ''; } public function visibleScenarioButtons() { return array('update', 'default'); } public function configScenarioButtons() { return array('default' => array('class' => 'btn btn-default', 'icon' => 'eye-open'), 'create' => array('class' => 'btn btn-primary', 'icon' => 'plus'), 'update' => array('class' => 'btn btn-primary', 'icon' => 'edit'), 'delete' => array('class' => 'btn btn-danger', 'icon' => 'remove')); } public function scenarioButtons() { return array(); } public function extraButtons() { return array(); } protected function renderStateButtons() { if ($this->model instanceof ActiveRecordInterface && $this->model->isNewRecord) { return null; } elseif ($this->model instanceof Model && empty($this->model->id)) { return null; } $sp253492 = $this->configStateButtons(); $sp6f2e28 = array(); foreach ($sp253492 as $sp34b61d => $spe1f0a7) { $spdfc6a7 = array('value' => function () use($sp34b61d, $spe1f0a7) { return Html::button(\Yii::t('app', $sp34b61d), $spe1f0a7); }); $sp6f2e28[$sp34b61d] = $spdfc6a7; } $spe1f0a7 = array('class' => $this->stateButtonGroupClass, 'buttonTemplate' => implode(' ', array_map(function ($sp73cf76) { return '{' . $sp73cf76 . '}'; }, array_keys($sp6f2e28))), 'buttons' => $sp6f2e28, 'group' => true, 'groupOptions' => array('class' => 'btn-group pull-left')); $spba6f8e = \Yii::createObject($spe1f0a7); return $spba6f8e->render(); } public function configStateButtons() { $sp206a7e = array(); $sp7cc51d = $this->stateMachine; if (!$sp7cc51d instanceof StateMachine) { return $sp206a7e; } $spe009e7 = $sp7cc51d->getEnabledTransitions($this->model); if (!$spe009e7) { return $sp206a7e; } foreach ($spe009e7 as $spaabb81) { $sp206a7e[$spaabb81->getName()] = array('data-workflow_module' => ClassHelper::getMatchModule($this, false, '/'), 'data-orm_module' => ClassHelper::getMatchModule($this->model, false, '/'), 'data-workflow_class' => ClassHelper::getShortName($sp7cc51d), 'data-transition_name' => $spaabb81->getName(), 'data-orm_class' => ClassHelper::getShortName($this->model), 'data-orm_id' => $this->model->id, 'class' => 'btn btn-primary state-transition', 'icon' => 'play'); } return $sp206a7e; } protected function renderActionButtons() { if ($this->model instanceof ActiveRecordInterface && $this->model->isNewRecord) { return null; } elseif ($this->model instanceof Model && empty($this->model->id)) { return null; } $sp9133cc = $this->model->scenarios(); $sp926b80 = $this->visibleScenarioButtons(); $sp4be8e4 = $this->configScenarioButtons(); $sp693c7f = $this->scenarioButtons(); $sp6f2e28 = array(); foreach ($sp9133cc as $spaa1573 => $sp0b8fcb) { if ($this->model->scenario === $spaa1573) { continue; } if (!in_array($spaa1573, $sp926b80)) { continue; } if (array_key_exists($spaa1573, $sp693c7f)) { $sp6f2e28[$spaa1573] = $sp693c7f[$spaa1573]; } else { $sp7bf456 = array(); if (array_key_exists($spaa1573, $sp4be8e4)) { $sp7bf456 = $sp4be8e4[$spaa1573]; } $spdfc6a7 = array('value' => function () use($spaa1573, $sp7bf456) { return Html::button(\Yii::t('app', $spaa1573), array_merge(array('id' => 'scenario-switch', 'class' => 'btn btn-default', 'data-card-switch' => $spaa1573), $sp7bf456)); }); $sp6f2e28[$spaa1573] = $spdfc6a7; } } $sp6f2e28 = array_merge($sp6f2e28, $this->extraButtons()); $spe1f0a7 = array('class' => $this->actionButtonGroupClass, 'buttonTemplate' => implode(' ', array_map(function ($sp73cf76) { return '{' . $sp73cf76 . '}'; }, array_keys($sp6f2e28))), 'buttons' => $sp6f2e28, 'group' => true, 'groupOptions' => array('class' => 'btn-group pull-right')); $spba6f8e = \Yii::createObject($spe1f0a7); return $spba6f8e->render(); } protected function renderSubpanels() { $spe3d13d = $this->subpanels(); $spe1f0a7 = array('class' => $this->subpanelGroupClass, 'subpanelTemplate' => implode(' ', array_map(function ($sp73cf76) { return '{' . $sp73cf76 . '}'; }, array_keys($spe3d13d))), 'subpanels' => $spe3d13d, 'model' => $this->model); $sp376cf6 = \Yii::createObject($spe1f0a7); echo $sp376cf6->render(); } public function isFormScenario() { if ($this->model->scenario === ActiveRecord::SCENARIO_DEFAULT) { return false; } return true; } protected function renderData() { if ($this->isFormScenario()) { $sp17db37 = FormWidget::widget(array_merge($this->formOptions, array('model' => $this->model, 'ajaxSubmit' => true, 'callback' => function ($spc7b84e, $sp1193db) { return $this->renderDataGroups($spc7b84e, $sp1193db); }))); } else { $sp17db37 = $this->renderDataGroups(); } return $sp17db37; } public function dependencyDataGroups() { $spf7300d = $this->dependencyAttributes(); $sp543cd0 = array('dynamic-attribute' => array('title' => 'Дополнительные атрибуты', 'items' => array())); if (empty($spf7300d) || !is_array($spf7300d) || empty($spf7300d['attribute']) || empty($spf7300d['dependency']) || !is_array($spf7300d['dependency']) || !$this->model->hasProperty($spf7300d['attribute']) || !is_scalar($this->model->hasProperty($spf7300d['attribute']))) { return array(); } $spc7a1c3 = array(); $sp1983fe = 1; foreach ($spf7300d['dependency'] as $sp0b8fcb => $sp5922fe) { $sp26f75e = $this->model->{$spf7300d['attribute']}; if ((string) $sp26f75e !== (string) $sp0b8fcb) { continue; } foreach ($sp5922fe as $spe77ce0) { if (count($sp5922fe) === 1) { $spc7a1c3[] = $spe77ce0; array_push($sp543cd0['dynamic-attribute']['items'], array('items' => $spc7a1c3)); break; } elseif (count($sp5922fe) <= 2 && $sp1983fe < 2) { $spc7a1c3[] = $spe77ce0; } elseif (count($sp5922fe) <= 2 && $sp1983fe === 2) { $spc7a1c3[] = $spe77ce0; array_push($sp543cd0['dynamic-attribute']['items'], array('items' => $spc7a1c3)); break; } elseif (count($sp5922fe) !== $sp1983fe && $sp1983fe % 2 === 0) { $spc7a1c3[] = $spe77ce0; array_push($sp543cd0['dynamic-attribute']['items'], array('items' => $spc7a1c3)); $spc7a1c3 = array(); } elseif (count($sp5922fe) === $sp1983fe) { $spc7a1c3[] = $spe77ce0; array_push($sp543cd0['dynamic-attribute']['items'], array('items' => $spc7a1c3)); break; } else { $spc7a1c3[] = $spe77ce0; } $sp1983fe++; } } if (empty($sp543cd0['dynamic-attribute']['items'])) { return array(); } return $sp543cd0; } public function dependencyAttributes() { return array(); } protected function renderDataGroups($spc7b84e = null, $sp1193db = null) { if (!isset($spc7b84e)) { $spc7b84e = $this->model; } $sp543cd0 = $this->dataGroups(); $sp6f2e28 = array(); if (!empty($sp543cd0['buttons'])) { $sp6f2e28 = $sp543cd0['buttons']; unset($sp543cd0['buttons']); } $sp543cd0 = array_merge($sp543cd0, $this->dependencyDataGroups()); $sp543cd0 = array_merge($sp543cd0, array('buttons' => $sp6f2e28)); return implode('', array_map(function ($spe1f0a7) use($sp1193db, $spc7b84e) { if (!isset($spe1f0a7['title']) || !isset($spe1f0a7['items'])) { return ''; } $spe1f0a7 = array_merge($spe1f0a7, array('class' => CardDataGroup::className(), 'form' => $sp1193db, 'model' => $spc7b84e)); $sp6ffc1b = \Yii::createObject($spe1f0a7); return $sp6ffc1b->render(); }, $sp543cd0)); } }