<?php
namespace app\common\db; use yii\db\ColumnSchemaBuilder; use yii\db\Expression; class Migration extends \yii\db\Migration { use SchemaBuilderTrait; private $pkColumn = 'id'; private $_tableFields = array(); private $_historyTableFields = array(); private $mappingDynamicTypes = array('integer' => 1, 'string' => 2, 'boolean' => 3); public $tableOptions = array(); public function init() { $this->tableOptions = null; if ($this->db->driverName === 'mysql') { $this->tableOptions = 'CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE=InnoDB'; } $this->_tableFields = array($this->pkColumn => $this->string(36), 'user_created_id' => $this->string(36), 'user_updated_id' => $this->string(36), 'history_version' => $this->bigInteger()->defaultValue(1), 'history_start_date' => $this->timestamp()->notNull()->defaultValue(new Expression('NOW()')), 'created_at' => $this->timestamp()->notNull()->defaultValue(new Expression('NOW()')), 'updated_at' => $this->timestamp()->notNull()->defaultValue(new Expression('NOW()')), 'deleted_at' => $this->timestamp(), 'is_deleted' => $this->integer()->defaultValue(0)); $this->_historyTableFields = array('history_end_date' => $this->timestamp()->notNull()); parent::init(); } public function alterTableUUID($spbbcb4e) { $sp8690a3 = $this->db->schema->quoteTableName($spbbcb4e); if (($this->db->driverName === 'mysql' || $this->db->driverName === 'mysqli') && $spbbcb4e !== 'migration') { $sp5c6a99 = "CREATE TRIGGER before_insert_{$spbbcb4e}\n  BEFORE INSERT ON {$sp8690a3}\n  FOR EACH ROW\n  IF new.{$this->pkColumn} IS NULL THEN SET new.{$this->pkColumn} = uuid();\n  ELSEIF new.{$this->pkColumn} = '' THEN SET new.{$this->pkColumn} = uuid();\n  END IF;"; $this->db->createCommand($sp5c6a99)->execute(); } elseif ($this->db->driverName === 'pgsql' && $spbbcb4e !== 'migration') { $sp5c6a99 = "ALTER TABLE {$sp8690a3} ALTER COLUMN {$this->pkColumn} SET DEFAULT uuid_generate_v1();"; $this->db->createCommand($sp5c6a99)->execute(); } elseif ($this->db->driverName === 'mssql') { } } public function createTable($spcd8912, $spa50713, $sp3ce8a0 = null) { if (empty($sp3ce8a0)) { $sp3ce8a0 = $this->tableOptions; } $this->createRawTable($spcd8912, $spa50713, $sp3ce8a0); } public function createRawTable($spcd8912, $spa50713, $sp3ce8a0 = null) { $spa50713 = array_merge($spa50713, $this->_tableFields); parent::createTable($spcd8912, $spa50713, $sp3ce8a0); $spbbcb4e = $this->db->schema->getRawTableName($spcd8912); $this->addPrimaryKey('pk_' . $this->pkColumn . '_' . $spbbcb4e, $spbbcb4e, $this->pkColumn); $this->alterTableUUID($spbbcb4e); } public function executeExpression($sp2b092d) { if (is_string($sp2b092d)) { $this->db->createCommand($sp2b092d)->execute(); } elseif (is_array($sp2b092d)) { foreach ($sp2b092d as $spe43ace) { $this->db->createCommand($spe43ace)->execute(); } } } public function createHistoryTable($spcd8912, $spa50713) { $spcd8912 = $this->getHistoryTable($spcd8912); $spa50713 = array_merge($spa50713, $this->_tableFields); $spa50713 = array_merge($spa50713, $this->_historyTableFields); parent::createTable($spcd8912, $spa50713); $spbbcb4e = $this->db->schema->getRawTableName($spcd8912); $this->addPrimaryKey('pk_' . $this->pkColumn . 'h_v' . $spbbcb4e, $spbbcb4e, array($this->pkColumn, 'history_version')); } public function createResponsibilityTable($spcd8912) { $spbbcb4e = $this->db->schema->getRawTableName($spcd8912); $spa50713 = array('employee_id' => $this->string(), $spbbcb4e . '_id' => $this->string()); $spa50713 = array_merge($spa50713, $this->_tableFields); $this->createTable($this->getResponsibilityTable($spcd8912), $spa50713); $this->createHistoryTable($this->getResponsibilityTable($spcd8912), $spa50713); } public function createPositionTable($spcd8912) { $spbbcb4e = $this->db->schema->getRawTableName($spcd8912); $spa50713 = array('position_id' => $this->string(), $spbbcb4e . '_id' => $this->string()); $spa50713 = array_merge($spa50713, $this->_tableFields); $this->createTable($this->getPositionTable($spcd8912), $spa50713); $this->createHistoryTable($this->getPositionTable($spcd8912), $spa50713); } public function createDepartmentTable($spcd8912) { $spbbcb4e = $this->db->schema->getRawTableName($spcd8912); $spa50713 = array('department_id' => $this->string(), $spbbcb4e . '_id' => $this->string()); $spa50713 = array_merge($spa50713, $this->_tableFields); $this->createTable($this->getDepartmentTable($spcd8912), $spa50713); $this->createHistoryTable($this->getDepartmentTable($spcd8912), $spa50713); } public function createDynamicAttributeTables($spcd8912) { $spbbcb4e = $this->db->schema->getRawTableName($spcd8912); $spa50713 = array('attribute' => $this->string(50), 'type' => $this->string(20)); $this->createTable($this->getDynamicAttributeTable($spcd8912), $spa50713); $spa50713 = array('dynamic_attribute_id' => $this->string(50), $spbbcb4e . '_id' => $this->string(), 'value' => $this->text()); $spa50713 = array_merge($spa50713, $this->_tableFields); $this->createTable($this->getDynamicAttributeValueTable($spcd8912), $spa50713); $this->createHistoryTable($this->getDynamicAttributeValueTable($spcd8912), $spa50713); } public function dropDynamicAttributeTables($spcd8912) { parent::dropTable($this->getDynamicAttributeTable($spcd8912)); parent::dropTable($this->getDynamicAttributeValueTable($spcd8912)); $this->dropHistoryTable($this->getDynamicAttributeValueTable($spcd8912)); } public function dropHistoryTable($spcd8912) { parent::dropTable($this->getHistoryTable($spcd8912)); } public function dropResponsibilityTable($spcd8912) { parent::dropTable($this->getResponsibilityTable($spcd8912)); $this->dropHistoryTable($this->getResponsibilityTable($spcd8912)); } public function dropPositionTable($spcd8912) { parent::dropTable($this->getPositionTable($spcd8912)); $this->dropHistoryTable($this->getPositionTable($spcd8912)); } public function dropDepartmentTable($spcd8912) { parent::dropTable($this->getDepartmentTable($spcd8912)); $this->dropHistoryTable($this->getDepartmentTable($spcd8912)); } protected function getHistoryTable($spcd8912) { return '{{%his__' . $this->db->schema->getRawTableName($spcd8912) . '}}'; } protected function getDepartmentTable($spcd8912) { return '{{%dep__' . $this->db->schema->getRawTableName($spcd8912) . '}}'; } protected function getResponsibilityTable($spcd8912) { return '{{%res__' . $this->db->schema->getRawTableName($spcd8912) . '}}'; } protected function getPositionTable($spcd8912) { return '{{%pos__' . $this->db->schema->getRawTableName($spcd8912) . '}}'; } protected function getDynamicAttributeTable($spcd8912) { return '{{%dyn__' . $this->db->schema->getRawTableName($spcd8912) . '}}'; } protected function getDynamicAttributeValueTable($spcd8912) { return '{{%dyn_val__' . $this->db->schema->getRawTableName($spcd8912) . '}}'; } public function addDynamicColumn($spcd8912, $sp829668, $sp5f82be = 'string') { $spcd8912 = $this->getDynamicAttributeTable($spcd8912); $spe6bc2b = $this->beginCommand("add column {$sp829668} {$sp5f82be} to table {$spcd8912}"); $this->db->createCommand()->insert($spcd8912, array('attribute' => $sp829668, 'type' => !isset($this->mappingDynamicTypes[$sp5f82be]) ? 'string' : $this->mappingDynamicTypes[$sp5f82be]))->execute(); if ($sp5f82be instanceof ColumnSchemaBuilder && $sp5f82be->comment !== null) { $this->db->createCommand()->addCommentOnColumn($spcd8912, $sp829668, $sp5f82be->comment)->execute(); } $this->endCommand($spe6bc2b); } public function dropDynamicColumn($spcd8912, $sp829668) { $spe6bc2b = $this->beginCommand("drop column {$sp829668} from table {$spcd8912}"); $spcd8912 = $this->getDynamicAttributeTable($spcd8912); $this->db->createCommand()->delete($spcd8912, array('attribute' => $sp829668))->execute(); $this->endCommand($spe6bc2b); } public function addColumn($spcd8912, $sp829668, $sp5f82be) { $spe6bc2b = $this->beginCommand("add column {$sp829668} {$sp5f82be} to table {$spcd8912}"); $this->db->createCommand()->addColumn($spcd8912, $sp829668, $sp5f82be)->execute(); if ($sp5f82be instanceof ColumnSchemaBuilder && $sp5f82be->comment !== null) { $this->db->createCommand()->addCommentOnColumn($spcd8912, $sp829668, $sp5f82be->comment)->execute(); } $this->endCommand($spe6bc2b); } public function addHistoryColumn($spcd8912, $sp829668, $sp5f82be) { $spcd8912 = $this->getHistoryTable($spcd8912); $this->addColumn($spcd8912, $sp829668, $sp5f82be); } public function dropHistoryColumn($spcd8912, $sp829668) { $this->dropColumn($this->getHistoryTable($spcd8912), $sp829668); } public function renameHistoryColumn($spcd8912, $sp34b61d, $sp9aa440) { $this->renameColumn($this->getHistoryTable($spcd8912), $sp34b61d, $sp9aa440); } public function alterHistoryColumn($spcd8912, $sp829668, $sp5f82be) { $this->alterColumn($this->getHistoryTable($spcd8912), $sp829668, $sp5f82be); } public function createBothTables($spcd8912, $spa50713, $sp3ce8a0 = null) { $this->createTable($spcd8912, $spa50713, $sp3ce8a0); $this->createHistoryTable($spcd8912, $spa50713); } public function dropBothTables($spcd8912) { $this->dropTable($spcd8912); $this->dropHistoryTable($spcd8912); } public function createAllTables($spcd8912, $spa50713, $sp3ce8a0 = null) { $this->createTable($spcd8912, $spa50713, $sp3ce8a0); $this->createHistoryTable($spcd8912, $spa50713); $this->createPositionTable($spcd8912); $this->createResponsibilityTable($spcd8912); $this->createDepartmentTable($spcd8912); } public function dropAllTables($spcd8912) { $this->dropTable($spcd8912); $this->dropHistoryTable($spcd8912); $this->dropResponsibilityTable($spcd8912); $this->dropPositionTable($spcd8912); $this->dropDepartmentTable($spcd8912); } public function addBothColumns($spcd8912, $sp829668, ColumnSchemaBuilder $sp5f82be) { $this->addColumn($spcd8912, $sp829668, $sp5f82be); $this->addHistoryColumn($spcd8912, $sp829668, $sp5f82be); } public function dropBothColumns($spcd8912, $sp829668) { $this->dropColumn($spcd8912, $sp829668); $this->dropHistoryColumn($spcd8912, $sp829668); } public function renameBothColumns($spcd8912, $sp34b61d, $sp9aa440) { $this->renameColumn($spcd8912, $sp34b61d, $sp9aa440); $this->renameHistoryColumn($spcd8912, $sp34b61d, $sp9aa440); } }