<?php
namespace app\common\rbac; use app\common\db\ActiveRecord; use app\common\helpers\ClassHelper; use app\common\db\ChangeAttributeEvent; use app\common\helpers\ArrayHelper; use app\common\helpers\CommonHelper; use app\common\logic\orm\AuthItem; use app\common\logic\orm\AuthItemChild; use yii\base\Event; use yii\db\AfterSaveEvent; use yii\helpers\Inflector; use yii\base\BaseObject; class Gate extends BaseObject { public $target; public $module; public $privileges; public $privilegesLabels = array(); public $privilegesParams = array(); public function init() { if (!$this->privileges) { $this->privileges = $this->isModelMode() ? $this->defaultModelPrivileges : $this->defaultClassPrivileges; } $this->privilegesLabels = array_merge($this->isModelMode() ? $this->defaultModelPrivilegesLabels : $this->defaultClassPrivilegesLabels, $this->privilegesLabels); if ($this->isModelMode()) { if (!$this->target instanceof ActiveRecord) { throw new \Exception('Invalid target given: must be class name or ActiveRecord object'); } $spfc4863 = $this->targetClassName; $sp36a341 = $spfc4863::getTitleAttribute(); $this->target->on(ActiveRecord::EVENT_AFTER_INSERT, array($this, 'createModelPermissions')); $this->target->on(ActiveRecord::EVENT_AFTER_DELETE, array($this, 'deleteModelPermissions')); $this->target->on($spfc4863::eventAfterChangeAttribute($sp36a341), array($this, 'changeModelPermissionsTitle')); } } public function can($sp9b3079 = null, $sp687c89 = true) { if (is_array($sp9b3079)) { return array_reduce($sp9b3079, function ($spc3d8be, $sp9b3079) use($sp687c89) { return $spc3d8be && $this->can($sp9b3079, $sp687c89); }, true); } $sp982b02 = CommonHelper::optionsValue($this->getPrivilegeParams($sp9b3079), $this); return \Yii::$app->user->can($this->getPermissionName($sp9b3079), $sp982b02, $sp687c89); } public function allow($sp73f911, $sp9b3079 = null) { $spabb77a = (array) $sp73f911; $spe193da = (array) $sp9b3079; $spa81279 = $this->getAuthItemChild($spabb77a, $spe193da); foreach ($spabb77a as $sp73f911) { foreach ($spe193da as $sp9b3079) { $sp2ef823 = ArrayHelper::findBy($spa81279, array('parent' => $sp73f911, 'child' => $this->getPermissionName($sp9b3079))); if (!$sp2ef823) { $sp2ef823 = $this->createAuthItemChild($sp73f911, $sp9b3079); if (!$sp2ef823->validate()) { throw new \Exception('Invalid auth item model: ' . implode(', ', ArrayHelper::flatten($sp2ef823->errors))); } $sp2ef823->save(); } $spa81279[] = $sp2ef823; } } return $spa81279; } public function deny($sp73f911, $sp9b3079 = null) { $spabb77a = $sp73f911 ? $sp73f911 : (array) $sp73f911; $spe193da = is_array($sp9b3079) ? $sp9b3079 : array($sp9b3079); $spa81279 = $this->getAuthItemChild($spabb77a, $spe193da); foreach ($spa81279 as $sp2ef823) { $sp2ef823->delete(); } return $spa81279; } public function createModelPermissions(AfterSaveEvent $spfce5f5) { $this->createAllPermissions(); } public function deleteModelPermissions(Event $spfce5f5) { foreach ($this->getAllPermissions() as $spa6635a) { if (!$spa6635a) { continue; } $spa6635a->delete(); } foreach ($this->getAllAuthItemChilds() as $sp2ef823) { if (!$sp2ef823) { continue; } $sp2ef823->delete(); } } public function changeModelPermissionsTitle(ChangeAttributeEvent $spfce5f5) { if ($this->target->isNewRecord) { return; } $spf4cd83 = $this->getAllPermissions(); foreach ($this->privileges as $sp9b3079) { $spa6635a = ArrayHelper::findBy($spf4cd83, array('name' => $this->getPermissionName($sp9b3079))); if (!$spa6635a) { $spa6635a = $this->createPermission($sp9b3079); } $spa6635a->title = $this->getPermissionTitle($sp9b3079); $spa6635a->save(); } } public function allowAll($sp73f911) { return $this->allow($sp73f911, $this->privileges); } public function denyAll($sp73f911) { return $this->deny($sp73f911, $this->privileges); } public function denyAllForAll() { return $this->denyAll(null); } public function getAuthItemChild($sp73f911 = null, $sp9b3079 = null) { $sp0eaf84 = AuthItemChild::find()->notDeleted()->currentUnion()->andFilterWhere(array('parent' => $sp73f911))->andWhere(array('child' => $this->getPermissionName($sp9b3079))); return is_array($sp73f911) || is_array($sp9b3079) ? $sp0eaf84->all() : $sp0eaf84->one(); } public function getAllAuthItemChilds($sp73f911 = null) { return $this->getAuthItemChild($sp73f911, $this->privileges); } public function createAuthItemChild($sp73f911, $sp9b3079 = null) { $sp2ef823 = new AuthItemChild(); $sp2ef823->setAttributes(array('parent' => $sp73f911, 'child' => $this->getPermissionName($sp9b3079))); return $sp2ef823; } public function createAllPermissions() { $spf4cd83 = $this->getAllPermissions(); foreach ($this->privileges as $sp9b3079) { $sp2ef823 = ArrayHelper::findBy($spf4cd83, array('name' => $this->getPermissionName($sp9b3079))); if ($sp2ef823) { continue; } $sp2ef823 = $this->createPermission($sp9b3079); if (!$sp2ef823->validate()) { throw new \Exception('Invalid auth item model: ' . implode(', ', ArrayHelper::flatten($sp2ef823->errors))); } $sp2ef823->save(false); } } public function createPermission($sp9b3079 = null) { $sp2ef823 = new AuthItem(); $sp2ef823->setAttributes(array('type' => AuthItem::TYPE_PERMISSION, 'name' => $this->getPermissionName($sp9b3079), 'title' => $this->getPermissionTitle($sp9b3079), 'hidden' => true)); return $sp2ef823; } public function getPermission($sp9b3079 = null) { $sp0eaf84 = AuthItem::find()->currentUnion()->notDeleted()->andWhere(array('name' => $this->getPermissionName($sp9b3079))); return is_array($sp9b3079) ? $sp0eaf84->all() : $sp0eaf84->one(); } public function getAllPermissions() { return $this->getPermission($this->privileges); } public function getPrivilegeLabel($sp9b3079 = null) { if (!$sp9b3079) { $sp9b3079 = '_empty'; } return ArrayHelper::getValue($this->privilegesLabels, $sp9b3079); } public function getPrivilegeParams($sp9b3079 = null) { if (!$sp9b3079) { $sp9b3079 = '_empty'; } return ArrayHelper::getValue($this->privilegesParams, $sp9b3079, array()); } public function getPermissionName($sp9b3079 = null) { if (is_array($sp9b3079)) { return array_map(function ($sp9b3079) { return $this->getPermissionName($sp9b3079); }, $sp9b3079); } $spf4c2af = $this->module; $sp9baa24 = $this->targetId; return "{$spf4c2af}_{$sp9baa24}" . ($sp9b3079 ? "_{$sp9b3079}" : ''); } public function getPermissionTitle($sp9b3079 = null) { if (is_array($sp9b3079)) { return array_map(function ($sp9b3079) { return $this->getPermissionTitle($sp9b3079); }, $sp9b3079); } $sp5b15e8 = $this->getPrivilegeLabel($sp9b3079); $sp11315b = $this->targetTitle; return trim("{$sp5b15e8} {$sp11315b}"); } public function getTargetClassName() { return $this->isModelMode() ? get_class($this->target) : $this->target; } public function getTargetShortName() { return ClassHelper::getShortName($this->targetClassName); } public function getTargetClassId() { return Inflector::camel2id($this->targetShortName); } public function getModelId() { if (!$this->isModelMode()) { return null; } return $this->target->id; } public function getModelTitle() { if (!$this->isModelMode()) { return null; } return $this->target->titleValue; } public function getTargetId() { $spc7b84e = $this->targetClassId; $sp9b1634 = $this->modelId; return $this->isModelMode() ? "{$spc7b84e}-{$sp9b1634}" : $spc7b84e; } public function getTargetTitle() { $sp294075 = $this->targetClassName; $sp11315b = method_exists($sp294075, 'modelTitle') ? $sp294075::modelTitle() : $this->targetShortName; $sp36a341 = $this->modelTitle; return trim("{$sp11315b} {$sp36a341}"); } public function isModelMode() { return is_object($this->target); } public function getDefaultClassPrivilegesLabels() { return array('view' => 'Просмотр объектов', 'create' => 'Создание объектов', 'edit' => 'Редактирование объектов', 'del' => 'Удаление объектов', '_empty' => 'Управление объектами'); } public function getDefaultModelPrivilegesLabels() { return array('view' => 'Просмотр объекта', 'create' => 'Создание объекта', 'edit' => 'Редактирование объекта', 'del' => 'Удаление объекта', '_empty' => 'Управление объектом'); } public function getDefaultClassPrivileges() { return array('view', 'create', 'edit', 'del'); } public function getDefaultModelPrivileges() { return array('view', 'edit', 'del'); } }