<?php
namespace app\modules\crm\widgets\card; use app\common\card\CardView; use app\common\helpers\ArrayHelper; use app\common\helpers\Html; use app\common\helpers\Url; use app\common\widgets\ActiveForm; use app\common\wrappers\Block; use app\modules\config\entities\CurrencyEntity; use app\modules\crm\models\orm\Order; use app\modules\crm\widgets\grid\OrderItemGrid; use app\modules\crm\workflow\OrderStateMachine; use app\modules\medical\models\orm\Ehr; use app\modules\medical\application\EhrServiceInterface; use app\modules\medical\widgets\grid\ReferralGrid; use yii\web\JsExpression; class OrderCard extends CardView { public $model; public $wrapper = true; public $ehrService; public function __construct(EhrServiceInterface $sp1a4482, array $spe1f0a7 = array()) { $this->stateMachine = new OrderStateMachine(); $this->ehrService = $sp1a4482; parent::__construct($spe1f0a7); } public function init() { parent::init(); $this->formOptions = array_merge($this->formOptions, array('action' => Url::to(array('/crm/ui/order/' . $this->model->scenario, 'id' => $this->model->id)), 'validationUrl' => Url::to(array('/crm/ui/order/validate-' . $this->model->scenario, 'id' => $this->model->id)))); } public function dataGroups() { return array('main' => array('title' => 'Данные заказа', 'items' => array(array('items' => array(array('attribute' => 'number', 'scenarios' => array('create' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { $spc7b84e->number = $spc7b84e->generateNumber(); return $sp1193db->field($spc7b84e, 'number')->label(false); }))), array('attribute' => 'status', 'scenarios' => array('create' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { $spc7b84e->status = Order::STATUS_NEW; return $sp1193db->field($spc7b84e, 'status')->select2(Order::statuses())->label(false); }), 'update' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'status')->select2(Order::statuses())->label(false); }), 'default' => array('value' => function (Order $spc7b84e) { return $spc7b84e->getStatusName(); }))))), array('items' => array(array('attribute' => 'currency', 'scenarios' => array('create' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { $spc7b84e->currency = 'RUB'; return $sp1193db->field($spc7b84e, 'currency')->select2(CurrencyEntity::currencyListData())->label(false); }), 'update' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'currency')->textInput(array('disabled' => true))->label(false); }), 'default' => array('value' => function (Order $spc7b84e) { $sp9382ee = CurrencyEntity::findCurrency($spc7b84e->currency); return $sp9382ee; }))), array('attribute' => 'currency_sum', 'scenarios' => array('create' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { $spc7b84e->currency_sum = '0.00'; return $sp1193db->field($spc7b84e, 'currency_sum')->textInput(array('disabled' => true))->label(false); }), 'update' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { if (empty($spc7b84e->currency_sum)) { $spc7b84e->currency_sum = '0.00'; } return $sp1193db->field($spc7b84e, 'currency_sum')->textInput(array('disabled' => true))->label(false); }), 'default' => array('value' => function (Order $spc7b84e) { $sp9382ee = CurrencyEntity::findCurrency($spc7b84e->currency); $sp2c09b5 = $sp9382ee; if (empty($spc7b84e->currency_sum)) { $spc7b84e->currency_sum = '0.00'; } return $spc7b84e->currency_sum . ' ' . $sp2c09b5; }))))), array('items' => array(array('attribute' => 'description', 'colSize' => 6), array('attribute' => 'ehr_id', 'colSize' => 6, 'scenarios' => array('default' => array('value' => function (Order $spc7b84e) { if (!$spc7b84e->ehr instanceof Ehr) { return ''; } return $spc7b84e->ehr->number; }), 'create' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { if (!empty($spc7b84e->ehr_id)) { $sp3e489d = $this->ehrService->getEhrById($spc7b84e->ehr_id); } return $sp1193db->field($spc7b84e, 'ehr_id')->select2(!isset($sp3e489d) ? array() : ArrayHelper::map(array($sp3e489d), 'id', 'number'), array(), array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/ehr/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (ehr) { if (ehr.loading) { return ehr.text; } else {return ehr.number;} }'), 'templateSelection' => new JsExpression('function (ehr) { if (ehr.number) {return ehr.number;} else { return ehr.text;} }')))->label(false); }), 'update' => array('value' => function (Order $spc7b84e, ActiveForm $sp1193db) { $spc7b84e->ehr; return $sp1193db->field($spc7b84e, 'ehr_id')->select2(ArrayHelper::map(array($spc7b84e->ehr), 'id', 'number'), array(), array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/ehr/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (ehr) { if (ehr.loading) { return ehr.text; } else {return ehr.number;} }'), 'templateSelection' => new JsExpression('function (ehr) { if (ehr.number) {return ehr.number;} else { return ehr.text;} }')))->label(false); }))))))), 'buttons' => array('title' => '', 'showFrame' => false, 'items' => array(array('items' => array(array('scenarios' => array('default' => array('value' => false, 'label' => false), 'update' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default'))), 'create' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default')))))))))); } public function subpanels() { return array('orderItems' => array('value' => function ($spc7b84e) { return OrderItemGrid::widget(array('orderId' => $spc7b84e->id, 'cardId' => $this->getId())); }, 'header' => 'Позиции заказа'), 'referrals' => array('value' => function ($spc7b84e) { return ReferralGrid::widget(array('order' => $spc7b84e, 'actionButtonTemplate' => '{refresh}{record}')); }, 'header' => 'Направления')); } public function renderTitle() { return $this->model->number; } public function wrapperOptions() { return array('wrapperClass' => Block::className(), 'header' => \Yii::t('app', 'Order')); } }