<?php
namespace app\modules\medical\widgets\card; use app\common\card\CardView; use app\common\helpers\CommonHelper; use app\common\helpers\Html; use app\common\helpers\Url; use app\common\logic\orm\Address; use app\common\logic\orm\Email; use app\common\logic\orm\Phone; use app\common\widgets\ActiveForm; use app\common\widgets\MultipleInput; use app\common\wrappers\Block; use app\modules\medical\application\PatientServiceInterface; use app\modules\medical\models\form\Patient; use app\modules\medical\widgets\grid\EhrGrid; use app\modules\medical\widgets\grid\PolicyGrid; use yii\widgets\MaskedInput; class PatientCard extends CardView { public $model; public $wrapper = true; public $patientService; public function __construct(PatientServiceInterface $sp816ca9, array $spe1f0a7 = array()) { $this->patientService = $sp816ca9; parent::__construct($spe1f0a7); } public function init() { $this->model = $this->patientService->getPatientForm($this->model); parent::init(); $this->formOptions = array_merge($this->formOptions, array('action' => Url::to(array('/medical/rest/patient/' . $this->model->scenario, 'id' => $this->model->id)), 'validationUrl' => Url::to(array('/medical/rest/patient/validate-' . $this->model->scenario, 'id' => $this->model->id)))); } public function title() { return $this->model->fullName; } public function dataGroups() { return array('personal' => array('title' => 'Данные пациента', 'items' => array(array('items' => array('last_name', 'first_name', 'middle_name')), array('items' => array(array('colSize' => 4, 'attribute' => 'sex', 'scenarios' => array('default' => array('value' => function ($spc7b84e) { return $spc7b84e->getSexName(); }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'sex')->select2(Patient::sexListData())->label(false); }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'sex')->select2(Patient::sexListData())->label(false); }))), array('colSize' => 4, 'attribute' => 'birthday', 'scenarios' => array('default' => array('value' => function ($spc7b84e) { return \Yii::$app->formatter->asDate($spc7b84e->birthday, CommonHelper::FORMAT_DATE_UI); }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'birthday')->dateInput()->label(false); }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'birthday')->dateInput()->label(false); }))))), array('items' => array(array('colSize' => 4, 'attribute' => 'snils', 'scenarios' => array('create' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'snils')->inputMask(array('mask' => '999-999-999-99'))->label(false); }), 'update' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'snils')->inputMask(array('mask' => '999-999-999-99'))->label(false); }))), array('colSize' => 4, 'attribute' => 'inn', 'scenarios' => array('create' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'inn')->inputMask(array('mask' => '999999999999'))->label(false); }), 'update' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'inn')->inputMask(array('mask' => '999999999999'))->label(false); }))))))), 'contacts' => array('title' => 'Контактные данные пациента', 'items' => array(array('items' => array(array('attribute' => 'phones', 'scenarios' => array('default' => array('value' => function ($spc7b84e) { $sp39f0c2 = $spc7b84e->phones; if (empty($sp39f0c2) || !is_array($sp39f0c2)) { return 'Телефоны не найдены'; } $sp17db37 = ''; $sp4b085d = count($sp39f0c2); $sp1983fe = 0; foreach ($sp39f0c2 as $spceeeaf) { $sp17db37 .= $spceeeaf['phone']; if ($sp4b085d !== $sp1983fe + 1) { $sp17db37 .= '<br>'; } $sp1983fe++; } return $sp17db37; }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'phones')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Phone::typeListData(), 'enableError' => true), array('type' => MaskedInput::class, 'name' => 'phone', 'title' => 'Телефон', 'options' => array('options' => array('class' => 'form-control'), 'mask' => '+7 (999) 999-99-99'), 'enableError' => true))))->label(false); }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'phones')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Phone::typeListData(), 'enableError' => true), array('type' => MaskedInput::class, 'name' => 'phone', 'title' => 'Телефон', 'options' => array('options' => array('class' => 'form-control'), 'mask' => '+7 (999) 999-99-99'), 'enableError' => true))))->label(false); }))), array('attribute' => 'emails', 'multiline' => true, 'scenarios' => array('default' => array('value' => function ($spc7b84e) { $spc81d80 = $spc7b84e->emails; if (empty($spc81d80) || !is_array($spc81d80)) { return 'Адреса не найдены'; } $sp17db37 = ''; $sp4b085d = count($spc81d80); $sp1983fe = 0; foreach ($spc81d80 as $sp374c0a) { $sp17db37 .= $sp374c0a['address']; if ($sp4b085d !== $sp1983fe + 1) { $sp17db37 .= '<br>'; } $sp1983fe++; } return $sp17db37; }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'emails')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Email::typeListData(), 'enableError' => true), array('name' => 'address', 'title' => 'Адрес', 'enableError' => true))))->label(false); }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'emails')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Email::typeListData(), 'enableError' => true), array('name' => 'address', 'title' => 'Адрес', 'enableError' => true))))->label(false); }))))), array('items' => array(array('colSize' => 12, 'labelSize' => 2, 'valueSize' => 10, 'attribute' => 'addresses', 'scenarios' => array('default' => array('value' => function ($spc7b84e) { $sp9ea227 = $spc7b84e->addresses; if (empty($sp9ea227) || !is_array($sp9ea227)) { return 'Адреса не найдены'; } $sp17db37 = ''; $sp4b085d = count($sp9ea227); $sp1983fe = 0; foreach ($sp9ea227 as $sp47bfe5) { $sp17db37 .= $sp47bfe5['type'] . ' ' . $sp47bfe5['region'] . ' ' . $sp47bfe5['area'] . ' ' . $sp47bfe5['settlement'] . ' ' . $sp47bfe5['street'] . ' ' . $sp47bfe5['house'] . ' ' . $sp47bfe5['building'] . ' ' . $sp47bfe5['room']; if ($sp4b085d !== $sp1983fe + 1) { $sp17db37 .= ', '; } $sp1983fe++; } return $sp17db37; }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'addresses')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => \Yii::t('app', 'Type address'), 'items' => Address::typeListData(), 'enableError' => true), array('name' => 'region', 'title' => \Yii::t('app', 'Region'), 'enableError' => true), array('name' => 'area', 'title' => \Yii::t('app', 'Area'), 'enableError' => true), array('name' => 'city', 'title' => \Yii::t('app', 'City'), 'enableError' => true), array('name' => 'settlement', 'title' => \Yii::t('app', 'Settlement'), 'enableError' => true), array('name' => 'street', 'title' => \Yii::t('app', 'Street'), 'enableError' => true), array('name' => 'house', 'title' => \Yii::t('app', 'House'), 'enableError' => true), array('name' => 'building', 'title' => \Yii::t('app', 'Building'), 'enableError' => true), array('name' => 'room', 'title' => \Yii::t('app', 'Room'), 'enableError' => true))))->label(false); }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'addresses')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => \Yii::t('app', 'Type address'), 'items' => Address::typeListData(), 'enableError' => true), array('name' => 'region', 'title' => \Yii::t('app', 'Region'), 'enableError' => true), array('name' => 'area', 'title' => \Yii::t('app', 'Area'), 'enableError' => true), array('name' => 'city', 'title' => \Yii::t('app', 'City'), 'enableError' => true), array('name' => 'settlement', 'title' => \Yii::t('app', 'Settlement'), 'enableError' => true), array('name' => 'street', 'title' => \Yii::t('app', 'Street'), 'enableError' => true), array('name' => 'house', 'title' => \Yii::t('app', 'House'), 'enableError' => true), array('name' => 'building', 'title' => \Yii::t('app', 'Building'), 'enableError' => true), array('name' => 'room', 'title' => \Yii::t('app', 'Room'), 'enableError' => true))))->label(false); }))))))), 'documents' => array('title' => 'Документы пациента', 'items' => array(array('items' => array(array('attribute' => 'passportSeries', 'scenarios' => array('create' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'passportSeries')->inputMask(array('mask' => '9999'))->label(false); }), 'update' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'passportSeries')->inputMask(array('mask' => '9999'))->label(false); }))), array('attribute' => 'passportNumber', 'scenarios' => array('create' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'passportNumber')->inputMask(array('mask' => '99999999'))->label(false); }), 'update' => array('value' => function (Patient $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'passportNumber')->inputMask(array('mask' => '99999999'))->label(false); }))))))), 'buttons' => array('title' => '', 'showFrame' => false, 'items' => array(array('items' => array(array('scenarios' => array('default' => array('value' => false, 'label' => false), 'update' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default'))), 'create' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default')))))))))); } public function subpanels() { return array('ehrs' => array('value' => function ($spc7b84e) { return EhrGrid::widget(array('patientId' => $spc7b84e->id)); }, 'header' => 'Медицинские карты'), 'policy' => array('value' => function ($spc7b84e) { return PolicyGrid::widget(array('patientId' => $spc7b84e->id)); }, 'header' => 'Полисы')); } public function wrapperOptions() { return array('wrapperClass' => Block::class, 'header' => \Yii::t('app', 'Patient')); } }