<?php
namespace app\modules\medical\widgets\card; use app\common\button\WidgetLoaderButton; use app\common\card\CardView; use app\common\helpers\ArrayHelper; use app\common\helpers\CommonHelper; use app\common\helpers\Html; use app\common\helpers\Url; use app\common\widgets\ActiveForm; use app\common\wrappers\Block; use app\modules\medical\MedicalModule; use app\modules\medical\models\orm\Ehr; use app\modules\medical\models\orm\Referral; use app\modules\medical\application\EhrServiceInterface; use app\modules\medical\widgets\grid\AttendanceGrid; use app\modules\medical\widgets\grid\ReferralItemGrid; use app\modules\medical\widgets\misc\ListMedworkerSchedule; use yii\web\JsExpression; class ReferralCard extends CardView { public $model; public $wrapper = true; public $ehrService; public function __construct(EhrServiceInterface $sp1a4482, array $spe1f0a7 = array()) { $this->ehrService = $sp1a4482; parent::__construct($spe1f0a7); } public function init() { parent::init(); $this->formOptions = array_merge($this->formOptions, array('action' => Url::to(array('/medical/rest/referral/' . $this->model->scenario, 'id' => $this->model->id)), 'validationUrl' => Url::to(array('/medical/rest/referral/validate-' . $this->model->scenario, 'id' => $this->model->id)))); } public function visibleScenarioButtons() { return array('update', 'default'); } public function extraButtons() { return array('record' => array('class' => WidgetLoaderButton::class, 'widgetClass' => ListMedworkerSchedule::class, 'widgetConfig' => array('model' => $this->model), 'disabled' => false, 'value' => 'Запись на приём', 'options' => array('class' => 'btn btn-primary', 'icon' => 'time'))); } public function dataGroups() { return array('main' => array('title' => 'Данные направления', 'items' => array(array('items' => array('number', array('attribute' => 'status', 'scenarios' => array('create' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { $spc7b84e->status = Referral::STATUS_NEW; return $sp1193db->field($spc7b84e, 'status')->select2(Referral::statuses())->label(false); }), 'update' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'status')->select2(Referral::statuses())->label(false); }), 'default' => array('value' => function (Referral $spc7b84e) { return $spc7b84e->getStatusName(); }))))), array('items' => array(array('attribute' => 'start_date', 'scenarios' => array('default' => array('value' => function (Referral $spc7b84e) { return \Yii::$app->formatter->asDate($spc7b84e->start_date, CommonHelper::FORMAT_DATE_UI); }), 'update' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'start_date')->dateInput()->label(false); }), 'create' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'start_date')->dateInput()->label(false); }))), array('attribute' => 'end_date', 'scenarios' => array('default' => array('value' => function (Referral $spc7b84e) { return \Yii::$app->formatter->asDate($spc7b84e->end_date, CommonHelper::FORMAT_DATE_UI); }), 'update' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'end_date')->dateInput()->label(false); }), 'create' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'end_date')->dateInput()->label(false); }))))), array('items' => array(array('attribute' => 'ehr_id', 'scenarios' => array('default' => array('value' => function (Referral $spc7b84e) { if (!$spc7b84e->ehr instanceof Ehr) { return ''; } return $spc7b84e->ehr->number; }), 'create' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { if (!empty($spc7b84e->ehr_id)) { $sp3e489d = $this->ehrService->getEhrById($spc7b84e->ehr_id); } return $sp1193db->field($spc7b84e, 'ehr_id')->select2(!isset($sp3e489d) ? array() : ArrayHelper::map(array($sp3e489d), 'id', 'number'), array(), array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/ehr/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (ehr) { if (ehr.loading) { return ehr.text; } else {return ehr.number;} }'), 'templateSelection' => new JsExpression('function (ehr) { if (ehr.number) {return ehr.number;} else { return ehr.text;} }')))->label(false); }), 'update' => array('value' => function (Referral $spc7b84e, ActiveForm $sp1193db) { $spc7b84e->ehr; return $sp1193db->field($spc7b84e, 'ehr_id')->select2(ArrayHelper::map(array($spc7b84e->ehr), 'id', 'number'), array(), array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/ehr/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (ehr) { if (ehr.loading) { return ehr.text; } else {return ehr.number;} }'), 'templateSelection' => new JsExpression('function (ehr) { if (ehr.number) {return ehr.number;} else { return ehr.text;} }')))->label(false); }))), 'description')))), 'buttons' => array('title' => '', 'showFrame' => false, 'items' => array(array('items' => array(array('scenarios' => array('default' => array('value' => false, 'label' => false), 'update' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default'))), 'create' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default')))))))))); } public function subpanels() { return array('referrals' => array('value' => function ($spc7b84e) { return ReferralItemGrid::widget(array('referralId' => $spc7b84e->id)); }, 'header' => 'Позиции направления'), 'attendances' => array('value' => function ($spc7b84e) { return AttendanceGrid::widget(array('referralId' => $spc7b84e->id)); }, 'header' => 'Записи на приём')); } public function renderTitle() { return $this->model->number; } public function wrapperOptions() { return array('wrapperClass' => Block::className(), 'header' => \Yii::t('app', 'Referral')); } }