<?php
namespace app\modules\medical\widgets\grid; use app\common\base\UniqueKey; use app\common\button\LinkActionButton; use app\common\db\ActiveRecord; use app\common\grid\GridView; use app\common\helpers\ArrayHelper; use app\common\helpers\CommonHelper; use app\common\helpers\Html; use app\common\helpers\Url; use app\modules\medical\models\finders\AttendanceFilter; use app\modules\medical\models\orm\Attendance; use app\modules\medical\models\orm\Ehr; use app\modules\medical\application\AttendanceService; use app\modules\medical\application\AttendanceServiceInterface; use app\modules\medical\application\EhrServiceInterface; use app\modules\medical\application\PatientServiceInterface; use app\modules\medical\application\ReferralServiceInterface; use app\modules\organization\models\orm\Employee; use app\modules\organization\application\EmployeeServiceInterface; use kartik\select2\Select2; use yii\web\JsExpression; class AttendanceGrid extends GridView { public $filterModel; public $attendanceService; public $referralService; public $referralId; public $visibleFilterRow = true; public $visibleActionButtons = false; public function __construct(ReferralServiceInterface $sp99c7dc, AttendanceServiceInterface $sp044c92, array $spe1f0a7 = array()) { $this->attendanceService = $sp044c92; $this->referralService = $sp99c7dc; parent::__construct($spe1f0a7); } public function init() { $this->filterModel = AttendanceFilter::ensure($this->filterModel, 'search', $this->formData); $this->filterModel->referralId = $this->referralId; $this->dataProvider = $this->attendanceService->getAttendanceList($this->filterModel); $this->actionButtons['create'] = array('class' => LinkActionButton::class, 'url' => array('/medical/ui/attendance/view', 'scenario' => ActiveRecord::SCENARIO_CREATE), 'isDynamicModel' => false, 'isAjax' => false, 'disabled' => false, 'value' => '', 'options' => array('class' => 'btn btn-xs btn-primary', 'icon' => 'plus')); $this->actionButtons['delete'] = array('class' => LinkActionButton::class, 'url' => array('/medical/rest/attendance/delete'), 'isDynamicModel' => true, 'isAjax' => true, 'disabled' => true, 'isConfirm' => true, 'afterUpdateBlock' => $this, 'value' => '', 'options' => array('class' => 'btn btn-xs btn-danger', 'icon' => 'remove')); $this->columns = array(array('attribute' => 'datetime', 'value' => function (Attendance $spc7b84e) { return Html::a(\Yii::$app->formatter->asDatetime($spc7b84e->datetime . date_default_timezone_get(), CommonHelper::FORMAT_DATETIME_UI), array('/medical/ui/attendance/view', 'id' => $spc7b84e->id)); }, 'filter' => function () { return Html::activeDateTimeInput($this->filterModel, 'datetime', array('class' => 'form-control')); }, 'format' => 'html', 'options' => array('class' => 'col-xs-2')), array('attribute' => 'employee_id', 'value' => function (Attendance $spc7b84e) { if ($spc7b84e->employee instanceof Employee) { return $spc7b84e->employee->fullName; } return ''; }, 'filter' => function () { return Select2::widget(array('model' => $this->filterModel, 'attribute' => 'employeeId', 'data' => ArrayHelper::map(Employee::find()->notDeleted()->all(), 'id', 'fullName'), 'options' => array('id' => UniqueKey::generate('employeeId'), 'placeholder' => 'Выберите значение ...'), 'pluginOptions' => array('allowClear' => true))); }), array('attribute' => 'ehr_id', 'value' => function (Attendance $spc7b84e) { if (!$spc7b84e->ehr instanceof Ehr) { return ''; } return Html::a($spc7b84e->ehr->number, array('/medical/ui/ehr/view', 'id' => $spc7b84e->ehr->id)); }, 'filter' => function () { $sp543cd0 = array(); if (!empty($this->filterModel->ehrId)) { $sp543cd0 = ArrayHelper::map(array(\Yii::$container->get(EhrServiceInterface::class)->getEhrById($this->filterModel->ehrId)), 'id', 'number'); } return Select2::widget(array('model' => $this->filterModel, 'attribute' => 'ehrId', 'data' => $sp543cd0, 'options' => array('id' => UniqueKey::generate('ehrId'), 'placeholder' => 'Выберите значение ...'), 'pluginOptions' => array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/ehr/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (ehr) { if (ehr.loading) { return ehr.text; } else {return ehr.number;} }'), 'templateSelection' => new JsExpression('function (ehr) { if (ehr.number) {return ehr.number;} else { return ehr.text;} }')))); }, 'format' => 'html'), array('header' => 'Пациент', 'value' => function (Attendance $spc7b84e) { if (!$spc7b84e->ehr instanceof Ehr) { return ''; } return $spc7b84e->ehr->patient->fullName; }, 'filter' => function () { $sp543cd0 = array(); if (!empty($this->filterModel->patientId)) { $sp543cd0 = ArrayHelper::map(array(\Yii::$container->get(PatientServiceInterface::class)->getPatientById($this->filterModel->patientId)), 'id', 'fullName'); } return Select2::widget(array('model' => $this->filterModel, 'attribute' => 'patientId', 'data' => $sp543cd0, 'options' => array('id' => UniqueKey::generate('patientId'), 'placeholder' => 'Выберите значение ...'), 'pluginOptions' => array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/patient/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (patient) { if (patient.loading) { return patient.text; } else {return patient.last_name + " " + patient.first_name + " " + patient.middle_name;} }'), 'templateSelection' => new JsExpression('function (patient) { if (patient.last_name) {return patient.last_name + " " + patient.first_name + " " + patient.middle_name;} else { return patient.text;} }')))); }), array('attribute' => 'status', 'value' => function (Attendance $spc7b84e) { return $spc7b84e->getStatusName(); }, 'filter' => function () { return Html::activeSelect2Input($this->filterModel, 'status', Attendance::statuses(), array('class' => 'form-control', 'empty' => true, 'placeholder' => 'Выберите значение ...'), array('allowClear' => true, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')))); }, 'format' => 'html'), array('attribute' => 'type', 'value' => function (Attendance $spc7b84e) { return $spc7b84e->typeName(); }, 'filter' => function () { return Html::activeSelect2Input($this->filterModel, 'type', Attendance::types(), array('class' => 'form-control', 'empty' => true, 'placeholder' => 'Выберите значение ...'), array('allowClear' => true, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')))); }, 'format' => 'html')); parent::init(); } }