<?php
namespace app\modules\medical\widgets\grid; use app\common\base\UniqueKey; use app\common\button\LinkActionButton; use app\common\db\ActiveRecord; use app\common\grid\GridView; use app\common\helpers\ArrayHelper; use app\common\helpers\Html; use app\common\helpers\Url; use app\modules\medical\models\finders\EhrFilter; use app\modules\medical\models\orm\Ehr; use app\modules\medical\models\orm\Patient; use app\modules\medical\application\EhrServiceInterface; use app\modules\medical\application\PatientServiceInterface; use kartik\select2\Select2; use yii\web\JsExpression; use app\modules\medical\models\form\Patient as PatientForm; class EhrGrid extends GridView { public $filterModel; public $patientId; public $patientService; public $ehrService; public $visibleFilterRow = true; public function __construct(PatientServiceInterface $sp816ca9, EhrServiceInterface $sp1a4482, array $spe1f0a7 = array()) { $this->patientService = $sp816ca9; $this->ehrService = $sp1a4482; parent::__construct($spe1f0a7); } public function init() { $this->filterModel = EhrFilter::ensure($this->filterModel, 'search', $this->formData); $this->filterModel->patientId = $this->patientId; $this->dataProvider = $this->ehrService->getEhrList($this->filterModel); $this->actionButtons['create'] = array('class' => LinkActionButton::class, 'url' => array('/medical/ui/ehr/view', 'patientId' => $this->patientId, 'scenario' => ActiveRecord::SCENARIO_CREATE), 'isDynamicModel' => false, 'isAjax' => false, 'disabled' => false, 'value' => '', 'options' => array('class' => 'btn btn-xs btn-primary', 'icon' => 'plus')); $this->actionButtons['delete'] = array('class' => LinkActionButton::class, 'url' => array('/medical/rest/ehr/delete'), 'isDynamicModel' => true, 'isAjax' => true, 'disabled' => true, 'isConfirm' => true, 'afterUpdateBlock' => $this, 'value' => '', 'options' => array('class' => 'btn btn-xs btn-danger', 'icon' => 'remove')); $this->columns = array(array('attribute' => 'number', 'format' => 'html', 'value' => function (Ehr $spc7b84e) { return Html::a($spc7b84e->number, array('/medical/ui/ehr/view', 'id' => $spc7b84e->id)); }), array('attribute' => 'type', 'format' => 'html', 'value' => function (Ehr $spc7b84e) { return $spc7b84e->getTypeName(); }, 'filter' => function () { return Html::activeSelect2Input($this->filterModel, 'type', Ehr::types(), array('class' => 'form-control', 'empty' => true, 'placeholder' => 'Выберите значение ...'), array('allowClear' => true, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')))); }), array('attribute' => 'patient_id', 'format' => 'html', 'value' => function (Ehr $spc7b84e) { if (!$spc7b84e->patient instanceof Patient) { return ''; } return Html::a($spc7b84e->patient->getFullName(), array('/medical/ui/patient/view', 'id' => $spc7b84e->patient->id)); }, 'filter' => function () { $sp543cd0 = array(); if (!empty($this->filterModel->patientId)) { $sp543cd0 = ArrayHelper::map(array(\Yii::$container->get(PatientServiceInterface::class)->getPatientById($this->filterModel->patientId)), 'id', 'fullName'); } return Select2::widget(array('model' => $this->filterModel, 'attribute' => 'patientId', 'data' => $sp543cd0, 'options' => array('id' => UniqueKey::generate('patientId'), 'placeholder' => 'Выберите значение ...'), 'pluginOptions' => array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/patient/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (patient) { if (patient.loading) { return patient.text; } else {return patient.last_name + " " + patient.first_name + " " + patient.middle_name;} }'), 'templateSelection' => new JsExpression('function (patient) { if (patient.last_name) {return patient.last_name + " " + patient.first_name + " " + patient.middle_name;} else { return patient.text;} }')))); })); parent::init(); } }