<?php
namespace app\modules\medical\widgets\grid; use app\common\base\UniqueKey; use app\common\button\LinkActionButton; use app\common\button\WidgetLoaderButton; use app\common\db\ActiveRecord; use app\common\grid\GridView; use app\common\helpers\ArrayHelper; use app\common\helpers\Html; use app\common\helpers\Url; use app\modules\crm\models\orm\Order; use app\modules\medical\models\finders\ReferralFilter; use app\modules\medical\models\orm\Ehr; use app\modules\medical\models\orm\Referral; use app\modules\medical\application\EhrServiceInterface; use app\modules\medical\application\PatientServiceInterface; use app\modules\medical\application\ReferralServiceInterface; use app\modules\medical\widgets\misc\ListMedworkerSchedule; use kartik\select2\Select2; use yii\web\JsExpression; class ReferralGrid extends GridView { public $filterModel; public $order; public $ehr; public $referralService; public $visibleFilterRow = true; public function __construct(ReferralServiceInterface $sp99c7dc, array $spe1f0a7 = array()) { $this->referralService = $sp99c7dc; parent::__construct($spe1f0a7); } public function init() { $this->filterModel = ReferralFilter::ensure($this->filterModel, 'search', $this->formData); $this->order = Order::ensureWeak($this->order); $this->ehr = Ehr::ensureWeak($this->ehr); empty($this->ehr->id) ?: ($this->filterModel->ehrId = $this->ehr->id); empty($this->order->id) ?: ($this->filterModel->orderId = $this->order->id); $this->dataProvider = $this->referralService->getReferralList($this->filterModel); $this->actionButtons['create'] = array('class' => LinkActionButton::class, 'url' => array('/medical/ui/referral/view', 'scenario' => ActiveRecord::SCENARIO_CREATE, 'ehrId' => $this->ehr->id), 'isDynamicModel' => false, 'isAjax' => false, 'disabled' => false, 'value' => '', 'options' => array('class' => 'btn btn-xs btn-primary', 'icon' => 'plus')); $this->actionButtons['record'] = array('class' => WidgetLoaderButton::class, 'widgetClass' => ListMedworkerSchedule::class, 'isDynamicModel' => true, 'disabled' => true, 'value' => '', 'options' => array('class' => 'btn btn-primary btn-xs', 'icon' => 'time')); $this->columns = array(array('attribute' => 'number', 'format' => 'html', 'value' => function (Referral $spc7b84e) { return Html::a($spc7b84e->number, array('/medical/ui/referral/view/', 'id' => $spc7b84e->id)); }), array('attribute' => 'status', 'value' => function (Referral $spc7b84e) { return $spc7b84e->getStatusName(); }, 'filter' => function () { return Html::activeSelect2Input($this->filterModel, 'status', Referral::statuses(), array('class' => 'form-control', 'empty' => true, 'placeholder' => 'Выберите значение ...'), array('allowClear' => true, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')))); }), array('attribute' => 'ehr_id', 'value' => function (Referral $spc7b84e) { if (!$spc7b84e->ehr instanceof Ehr) { return ''; } return Html::a($spc7b84e->ehr->number, array('/medical/ui/ehr/view', 'id' => $spc7b84e->ehr->id)); }, 'filter' => function () { $sp543cd0 = array(); if (!empty($this->filterModel->ehrId)) { $sp543cd0 = ArrayHelper::map(array(\Yii::$container->get(EhrServiceInterface::class)->getEhrById($this->filterModel->ehrId)), 'id', 'number'); } return Select2::widget(array('model' => $this->filterModel, 'attribute' => 'ehrId', 'data' => $sp543cd0, 'options' => array('id' => UniqueKey::generate('ehrId'), 'placeholder' => 'Выберите значение ...'), 'pluginOptions' => array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/ehr/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (ehr) { if (ehr.loading) { return ehr.text; } else {return ehr.number;} }'), 'templateSelection' => new JsExpression('function (ehr) { if (ehr.number) {return ehr.number;} else { return ehr.text;} }')))); }, 'format' => 'html'), array('header' => 'Пациент', 'value' => function (Referral $spc7b84e) { if (!$spc7b84e->ehr instanceof Ehr) { return ''; } return $spc7b84e->ehr->patient->fullName; }, 'filter' => function () { $sp543cd0 = array(); if (!empty($this->filterModel->patientId)) { $sp543cd0 = ArrayHelper::map(array(\Yii::$container->get(PatientServiceInterface::class)->getPatientById($this->filterModel->patientId)), 'id', 'fullName'); } return Select2::widget(array('model' => $this->filterModel, 'attribute' => 'patientId', 'data' => $sp543cd0, 'options' => array('id' => UniqueKey::generate('patientId'), 'placeholder' => 'Выберите значение ...'), 'pluginOptions' => array('allowClear' => true, 'minimumInputLength' => 1, 'language' => array('errorLoading' => new JsExpression('function () { return \'Ничего не найдено.\'; }')), 'ajax' => array('url' => Url::to(array('/medical/rest/patient/index')), 'dataType' => 'json', 'delay' => 1000, 'data' => new JsExpression('function (params) { return {q:params.term, page: params.page || 1}; }'), 'processResults' => new JsExpression('function (data, params) { return { results: data, pagination: {more: (params.page * 10) < data.count_filtered}}; }')), 'escapeMarkup' => new JsExpression('function (markup) { return markup; }'), 'templateResult' => new JsExpression('function (patient) { if (patient.loading) { return patient.text; } else {return patient.last_name + " " + patient.first_name + " " + patient.middle_name;} }'), 'templateSelection' => new JsExpression('function (patient) { if (patient.last_name) {return patient.last_name + " " + patient.first_name + " " + patient.middle_name;} else { return patient.text;} }')))); })); parent::init(); } }