<?php
namespace app\modules\organization\widgets\card; use app\common\card\CardView; use app\common\helpers\CommonHelper; use app\common\helpers\Html; use app\common\helpers\Url; use app\common\logic\orm\Address; use app\common\logic\orm\Email; use app\common\logic\orm\Phone; use app\common\widgets\ActiveForm; use app\common\widgets\MultipleInput; use app\common\wrappers\Block; use app\modules\medical\models\orm\Speciality; use app\modules\organization\application\EmployeeServiceInterface; use app\modules\organization\models\orm\Employee; use app\modules\organization\OrganizationModule; use app\modules\security\models\orm\User; use app\modules\workplan\widgets\grid\WorkplanGrid; use yii\widgets\MaskedInput; use app\modules\organization\models\form\Employee as EmployeeForm; class EmployeeCard extends CardView { public $model; public $wrapper = true; public $employeeService; public function __construct(EmployeeServiceInterface $sp5ccad6, array $spe1f0a7 = array()) { $this->employeeService = $sp5ccad6; parent::__construct($spe1f0a7); } public function init() { $this->model = $this->employeeService->getEmployeeForm($this->model); parent::init(); $this->formOptions = array_merge($this->formOptions, array('action' => Url::to(array('/organization/rest/employee/' . $this->model->scenario, 'id' => $this->model->id)), 'validationUrl' => Url::to(array('/organization/rest/employee/validate-' . $this->model->scenario, 'id' => $this->model->id)))); } protected function renderTitle() { echo $this->model->fullName; } public function dataGroups() { return array('personal' => array('title' => OrganizationModule::t('common', 'Employee\'s data'), 'items' => array(array('items' => array(array('attribute' => 'last_name'), array('attribute' => 'sex', 'scenarios' => array('default' => array('value' => function (EmployeeForm $spc7b84e) { return $spc7b84e->getSexName(); }), 'create' => array('value' => function (EmployeeForm $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'sex')->select2(Employee::sexListData())->label(false); }), 'update' => array('value' => function (EmployeeForm $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'sex')->select2(Employee::sexListData())->label(false); }))))), array('items' => array(array('attribute' => 'first_name'), array('attribute' => 'birthday', 'scenarios' => array('default' => array('value' => function ($spc7b84e) { return \Yii::$app->formatter->asDate($spc7b84e->birthday, CommonHelper::FORMAT_DATE_UI); }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'birthday')->dateInput()->label(false); }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'birthday')->dateInput()->label(false); }))))), array('items' => array(array('attribute' => 'middle_name'), array('attribute' => 'user_id', 'scenarios' => array('default' => array('value' => function (EmployeeForm $spc7b84e) { if (!empty($spc7b84e['user'])) { return $spc7b84e['user']['login']; } return ''; }), 'create' => array('value' => function (EmployeeForm $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'user_id')->select2(User::listAll(null, 'login'))->label(false); }), 'update' => array('value' => function (EmployeeForm $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'user_id')->select2(User::listAll(null, 'login'))->label(false); }))))), array('items' => array(array('colSize' => '6', 'attribute' => 'speciality_id', 'scenarios' => array('create' => array('value' => function (EmployeeForm $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'speciality_id')->select2(Speciality::listAll())->label(false); }), 'update' => array('value' => function (EmployeeForm $spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'speciality_id')->select2(Speciality::listAll())->label(false); }), 'default' => array('value' => function (EmployeeForm $spc7b84e) { if (!empty($spc7b84e['speciality'])) { return $spc7b84e['speciality']['title']; } }))))))), 'contacts' => array('title' => 'Контактные данные сотрудника', 'items' => array(array('items' => array(array('attribute' => 'phones', 'scenarios' => array('default' => array('value' => function ($spc7b84e) { $sp39f0c2 = $spc7b84e->phones; if (empty($sp39f0c2) || !is_array($sp39f0c2)) { return 'Телефоны не найдены'; } $sp17db37 = ''; $sp4b085d = count($sp39f0c2); $sp1983fe = 0; foreach ($sp39f0c2 as $spceeeaf) { $sp17db37 .= $spceeeaf['phone']; if ($sp4b085d !== $sp1983fe + 1) { $sp17db37 .= '<br>'; } $sp1983fe++; } return $sp17db37; }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'phones')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Phone::typeListData(), 'enableError' => true), array('type' => MaskedInput::class, 'name' => 'phone', 'title' => 'Телефон', 'options' => array('options' => array('class' => 'form-control'), 'mask' => '+7 (999) 999-99-99'), 'enableError' => true))))->label(false); }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'phones')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Phone::typeListData(), 'enableError' => true), array('type' => MaskedInput::class, 'name' => 'phone', 'title' => 'Телефон', 'options' => array('options' => array('class' => 'form-control'), 'mask' => '+7 (999) 999-99-99'), 'enableError' => true))))->label(false); }))), array('attribute' => 'emails', 'multiline' => true, 'scenarios' => array('default' => array('value' => function ($spc7b84e) { $spc81d80 = $spc7b84e->emails; if (empty($spc81d80) || !is_array($spc81d80)) { return 'Адреса не найдены'; } $sp17db37 = ''; $sp4b085d = count($spc81d80); $sp1983fe = 0; foreach ($spc81d80 as $sp374c0a) { $sp17db37 .= $sp374c0a['address']; if ($sp4b085d !== $sp1983fe + 1) { $sp17db37 .= '<br>'; } $sp1983fe++; } return $sp17db37; }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'emails')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Email::typeListData(), 'enableError' => true), array('name' => 'address', 'title' => 'Адрес', 'enableError' => true))))->label(false); }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'emails')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => 'Тип', 'items' => Email::typeListData(), 'enableError' => true), array('name' => 'address', 'title' => 'Адрес', 'enableError' => true))))->label(false); }))))), array('items' => array(array('colSize' => 12, 'labelSize' => 2, 'valueSize' => 10, 'attribute' => 'addresses', 'scenarios' => array('default' => array('value' => function ($spc7b84e) { $sp9ea227 = $spc7b84e->addresses; if (empty($sp9ea227) || !is_array($sp9ea227)) { return 'Адреса не найдены'; } $sp17db37 = ''; $sp4b085d = count($sp9ea227); $sp1983fe = 0; foreach ($sp9ea227 as $sp47bfe5) { $sp17db37 .= $sp47bfe5['type'] . ' ' . $sp47bfe5['region'] . ' ' . $sp47bfe5['area'] . ' ' . $sp47bfe5['settlement'] . ' ' . $sp47bfe5['street'] . ' ' . $sp47bfe5['house'] . ' ' . $sp47bfe5['building'] . ' ' . $sp47bfe5['room']; if ($sp4b085d !== $sp1983fe + 1) { $sp17db37 .= ', '; } $sp1983fe++; } return $sp17db37; }), 'create' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'addresses')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => \Yii::t('app', 'Type address'), 'items' => Address::typeListData(), 'enableError' => true), array('name' => 'region', 'title' => \Yii::t('app', 'Region'), 'enableError' => true), array('name' => 'area', 'title' => \Yii::t('app', 'Area'), 'enableError' => true), array('name' => 'city', 'title' => \Yii::t('app', 'City'), 'enableError' => true), array('name' => 'settlement', 'title' => \Yii::t('app', 'Settlement'), 'enableError' => true), array('name' => 'street', 'title' => \Yii::t('app', 'Street'), 'enableError' => true), array('name' => 'house', 'title' => \Yii::t('app', 'House'), 'enableError' => true), array('name' => 'building', 'title' => \Yii::t('app', 'Building'), 'enableError' => true), array('name' => 'room', 'title' => \Yii::t('app', 'Room'), 'enableError' => true))))->label(false); }), 'update' => array('value' => function ($spc7b84e, ActiveForm $sp1193db) { return $sp1193db->field($spc7b84e, 'addresses')->widget(MultipleInput::class, array('columns' => array(array('name' => 'type', 'type' => 'dropDownList', 'title' => \Yii::t('app', 'Type address'), 'items' => Address::typeListData(), 'enableError' => true), array('name' => 'region', 'title' => \Yii::t('app', 'Region'), 'enableError' => true), array('name' => 'area', 'title' => \Yii::t('app', 'Area'), 'enableError' => true), array('name' => 'city', 'title' => \Yii::t('app', 'City'), 'enableError' => true), array('name' => 'settlement', 'title' => \Yii::t('app', 'Settlement'), 'enableError' => true), array('name' => 'street', 'title' => \Yii::t('app', 'Street'), 'enableError' => true), array('name' => 'house', 'title' => \Yii::t('app', 'House'), 'enableError' => true), array('name' => 'building', 'title' => \Yii::t('app', 'Building'), 'enableError' => true), array('name' => 'room', 'title' => \Yii::t('app', 'Room'), 'enableError' => true))))->label(false); }))))))), 'buttons' => array('title' => '', 'showFrame' => false, 'items' => array(array('items' => array(array('scenarios' => array('default' => array('value' => false, 'label' => false), 'update' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'Save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'Cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default'))), 'create' => array('label' => false, 'value' => Html::submitButton(\Yii::t('app', 'save'), array('class' => 'btn btn-primary', 'icon' => 'saved')) . '&nbsp' . Html::button(\Yii::t('app', 'cancel'), array('class' => 'btn btn-default', 'data-card-switch' => 'default')))))))))); } public function subpanels() { return array('workplans' => array('value' => function ($spc7b84e) { return WorkplanGrid::widget(array('employeeId' => $spc7b84e->id)); }, 'header' => 'Рабочие планы')); } public function wrapperOptions() { return array('wrapperClass' => Block::class, 'header' => 'Сотрудник'); } }